---
title: XRInputSourceArray.values()
slug: Web/API/XRInputSourceArray/values
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Iterator
  - Method
  - Mixed
  - Reality
  - Reference
  - Sources
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR API Reference
  - XR
  - XRInputSourceArrray
  - augmented
  - values
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p>The {{domxref("XRInputSourceArray")}} method  <code><strong>values()</strong></code> returns a {{Glossary("JavaScript")}} <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Iterator">iterator</a></code> that can walk over the list of {{domxref("XRInputSource")}} objects contained in the array, from first to last.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrInputSourceArray</em>.values();
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A JavaScript <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Iterator">iterator</a></code> that can be used to walk through the list of {{domxref("XRInputSource")}} objects in the array, starting with the first entry (at index 0) and proceeding straight through the list.</p>

<h2 id="Examples">Examples</h2>

<p>This example snippet walks through each input and calls the function <code>checkInput()</code>  with each returned value.</p>

<pre class="brush: js">for (const source of xrSession.inputSources.values()) {
  checkInput(source);
}
</pre>

<p>Here, <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code> is used to iterate over the array's contents. Each pass through the loop, <code>source</code> is the next {{domxref("XRInputSource")}} in the list. The loop exits once every input has been delivered to <code>checkInput()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#xrinputsourcearray','XRInputSourceArray')}}<sup><a href="#spec-iterables">1</a></sup></td>
   <td>{{Spec2('WebXR')}}</td>
   <td><code>XRInputSourceArray</code> interface</td>
  </tr>
 </tbody>
</table>

<p><a id="spec-iterables">[1]</a> See {{SectionOnPage("/en-US/docs/MDN/Contribute/Howto/Write_an_API_reference/Information_contained_in_a_WebIDL_file", "Iterator-like methods")}} for information on how an <code>iterable</code> declaration in an interface definition causes <code>entries()</code>, <code>forEach()</code>, <code>keys()</code>, and <code>values()</code> methods to be exposed from objects that implement the interface.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSourceArray.values")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li>The {{domxref("XRInputSourceArray")}} method {{domxref("XRInputSourceArray.keys", "keys()")}}</li>
 <li>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array">Array</a></code> method <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/values">values(</a>)</code></li>
 <li>{{domxref("XRInputSource")}}</li>
</ul>
